<?php
/*************************************************************************************/
/*                                                                                   */
/*      Thelia	                                                            		 */
/*                                                                                   */
/*      Copyright (c) Octolys Development		                                     */
/*		email : thelia@octolys.fr		        	                             	 */
/*      web : http://www.octolys.fr						   							 */
/*                                                                                   */
/*      This program is free software; you can redistribute it and/or modify         */
/*      it under the terms of the GNU General Public License as published by         */
/*      the Free Software Foundation; either version 2 of the License, or            */
/*      (at your option) any later version.                                          */
/*                                                                                   */
/*      This program is distributed in the hope that it will be useful,              */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of               */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                */
/*      GNU General Public License for more details.                                 */
/*                                                                                   */
/*      You should have received a copy of the GNU General Public License            */
/*      along with this program; if not, write to the Free Software                  */
/*      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA    */
/*                                                                                   */
/*************************************************************************************/
?>
<?php
include_once(realpath(dirname(__FILE__)) . "/../../../classes/PluginsClassiques.class.php");
	
	
	class Filtredivision extends PluginsClassiques{

		function Filtredivision(){
	
			$this->PluginsClassiques();	
	
		}
		
		function init()
		{
			$this->ajout_desc("filtredivision", "Filtre Division", "Plugin qui effectue une division une multiplication ou un modulo avant les autres filtres.", 1);

			$module = new Modules();
			$module->charger("filtredivision");
			$module->classement = 10;
			$module->maj();
		}
		
		function action(){
			
            global $res;

		    if (preg_match_all("`\#FILTRE_division\(([^\/)]*)([\/\*\%])([^\))]*)\)`", $res, $cut))
			{
				for($i = 0; $i < count($cut[1]); $i++)
				{
					$tab[$i] = "";
					if ($cut[1] && $cut[3])
					{
						$tab[$i] = "/OPERATION_FAILED/";
						if (is_numeric($cut[1][$i]) && is_numeric($cut[3][$i]))
						{
							if ($cut[2][$i] == "/" && (int) $cut[3][$i] != 0)
								$tab[$i] = (string) round((int) $cut[1][$i] / (int) $cut[3][$i]);
							else if ($cut[2][$i] == "*")
								$tab[$i] = (string) round((int) $cut[1][$i] * (int) $cut[3][$i]);
							else if ($cut[2][$i] == "%")
								$tab[$i] = (string) ((int) $cut[1][$i] % (int) $cut[3][$i]);
						}
					}
				}

				$res = str_replace($cut[0], $tab, $res);
			}
		}
		
	}


?>
